// 
//  PUSH BON  FOR TTI
// Oh!X 1989-11
// for X-BASIC' 2015 by AIG-Soft
// 全機種対応

// X,Y		カーソル座標
// S		ステップ数
// D		カーソルの方向
// R		ラウンド
// G		残りライフ
// $9f00～	仮想VRAM

enum 
	// 幅は一部定数化したが、プログラム内部には即値記述が多く全ては置き換えられてない
	MWX		=7			// 1面横幅
	MWY		=7			// 1面縦幅
	MEN_DATAS=MWX*MWY	// 1面分データバイト数
	MENS	=10			// 全面数
	LIFE	=5			// life数
	//
	WX		=40			// 表示画面サイズ
	WY		=25
	KEY_Y	=WY+5		// キーの表示開始y座標
	KEY_X	=WX/2-5
	// 移動方向
	MOVE_UP		=0
	MOVE_RIGHT
	MOVE_DOWN
	MOVE_LEFT
	// キーコード
	ESC		=&h1b
	KDOWN	='2'
	KLEFT	='4'
	KRIGHT	='6'
	KUP		='8'
	KSPC	=' '
	KGIVEUP	='G'
endenum

dim int	touchNo(10)	:// タッチエリア番号 / touch area number
int touchallcnt		:// タッチエリア数	/ the number of touch area

font("HiraMinProN-W6"):// 等幅フォントではないので全文字１桁
int fzenhan
width(WX,,fzenhan,NO)
int xw=1:// 全角１文字の桁数 / double-width 1 character's columus
if fzenhan then xw=2

beep2(13,YES)
tborder(1,CTHCYAN)
setTouchArea(0,0,0,0,0,YES):// これがないと任意のタッチ座標を得られない / Need for getting any touch coordinate

cls()

// 面データ
dim char men(MEN_DATAS*MENS)

int fp=fopen("PUSHBON.DAT","r")
if fopenError(fp) then {
	print "面データが見つかりません"
	end
}
fread(men,MEN_DATAS*MENS,fp)
fclose(fp)

// 1面分データ
dim char men1(MEN_DATAS)
// 仮想VRAM
dim char vram(WX,WY)

// MAIN ROUTINE
// 9
while YES
	int R=0
	printWaku()
	int G=LIFE
	printScreen()
	copyMenData()
	printMen()
	hitKey(NO,"始めるにはここをタップ","Tap here to start!")

	// 操作キー設定
	printKeys(KEY_X,KEY_Y)

	setFunctionKey(0,"ギブアップ",KGIVEUP)
	setFunctionKeyBackgroundImage()
	displayFunctionKey(YES,0,0)

	int K,O,P,Q,A,B,C,I,J,U,V,W

	// 11
	while YES
		int T=0,X=0,Y=0,D=0,S=0
		printScreen()
		beep()

		// 12
		printBlock(X,Y,0)
		writeKvram(X,Y,0)
		printDirection(X,Y)
		writeKvram(X,Y,6)

		// 13
		repeat
			repeat
				K=inkey()
			until K<>0
			switch K
				case KLEFT:// CURSOR LEFT	455
					leftRight(MOVE_LEFT ,0,-1)
					break
				
				case KRIGHT:// CURSOR RIGHT	456
					leftRight(MOVE_RIGHT,6,+1)
					break
				
				case KUP:// CURSOR UP	458
					upDown(MOVE_UP  ,0,-1)
					break
				
				case KDOWN:// CURSOR DOWN	457
					upDown(MOVE_DOWN,6,+1)
					break

				case KSPC
					pushBlock()
					inc(S)
					if S>=256 then K=KGIVEUP:break
					printStep()
					if checkBlockYoko()<>0 then {
						roundClear()
						break
					}
					if checkBlockTate()<>0 then {
						roundClear()
						break
					}
					wait(0.5)
					break
			endswitch
		until K=KGIVEUP:// ->13,12
		if K=KGIVEUP then {
			// GIVE UP!!!
			// 20
			locate(6,11):print "             "
			locate(6,12):print "  GIVE UP!!  "
			locate(6,13):print "             "
			dec(G)
			printScreen()
			bell(2)
			wait(2.0)
		}
		printTitle()
		if G=0 then {
			// 21
			// GAME OVER
			locate(6,11):print "＊ ＊ ＊ ＊ ＊ ＊ ＊"
			locate(6,12):print "　＊Ｇａｍｅ　Ｏｖｅｒ＊　"
			locate(6,13):print "＊ ＊ ＊ ＊ ＊ ＊ ＊"
			bell(3)
			hitKey(NO)
			break:// GOTO 9
		}
		copyMenData()
		printMen()
	endwhile:// ->11
endwhile:// ->9
end

// 457,458
func upDown(direc;int,limitY;int,dy;int)
	wait(0.5,NO)
	beep2(0)
	int fchange=NO
	int Q
	D=direc
	if Y<>limitY then {
		Q=Y+dy
		if readKvram(X,Q)=0 then fchange=YES
	}
	// 453
	printBlock(X,Y,0)
	writeKvram(X,Y,0)
	if fchange then Y=Q
	printDirection(X,Y)
	writeKvram(X,Y,6)
	waitEnd()
endfunc

// 455,456
func leftRight(direc;int,limitX;int,dx;int)
	wait(0.5,NO)
	beep2(0)
	int fchange=NO
	int Q
	D=direc
	if X<>limitX then {
		Q=X+dx
		if readKvram(Q,Y)=0 then fchange=YES
	}
	// 454
	printBlock(X,Y,0)
	writeKvram(X,Y,0)
	if fchange then X=Q
	printDirection(X,Y)
	writeKvram(X,Y,6)
	waitEnd()
endfunc

// 23 ROUND CLEAR
func roundClear()
	locate(6,11):print "* * * * * * *"
	locate(6,12):print " ROUND CLEAR "
	locate(6,13):print "* * * * * * *"
	bell(3)
	hitKey(NO)
	inc(R)
	if R=10 then R=0
endfunc

// 250 BLOCK YOKO CHECK
func int checkBlockYoko()
	int I=0
	int O=0
	A=MWX
	repeat
		C=5
		repeat
			if men1(I)=4 then {
				O=sub251(I,O)
			}
			I=I+1
			dec(C)
		until C=0
		I=I+2
		dec(A)
	until A=0
	return(O)
endfunc

func int sub251(I;int,O;int)
	int L=2
	repeat
		I=I+1
		if men1(I)<>4 then return(O)
		dec(L)
	until L=0
	return(10)
endfunc

// 255 BLOCK TATE CHECK
func int checkBlockTate()
	int I=0
	int O=0
	A=MWX
	repeat
		int II=I
		C=5
		repeat
			if men1(II)=4 then {
				O=sub256(II,O)
			}
			dec(C)
			II=II+MWX
		until C=0
		I=I+1
		dec(A)
	until A=0
	return(O)
endfunc

func int sub256(I;int,O;int)
	int L=2
	repeat
		I=I+MWX
		if men1(I)<>4 then return(O)
		dec(L)
	until L=0
	return(10)
endfunc

// 300 BLOCK PUSH
func pushBlock()
	T=0
	int xx=X,yy=Y,dd=D
	int fretry=NO
	repeat
		switch D
			case MOVE_UP:// BLOCK UP PUSH
				fretry=pushBlockUp(fretry)
				break
			case MOVE_RIGHT:// BLOCK RIGHT PUSH
				fretry=pushBlockRight(fretry)
				break
			case MOVE_DOWN:// BLOCK DOWN PUSH
				fretry=pushBlockDown(fretry)
				break
			case MOVE_LEFT:// BLOCK LEFT PUSH
				fretry=pushBlockLeft(fretry)
				break
		endswitch
		// fretry=YESのときは上記処理内で方向が変わったのでその方向も再処理
	until fretry=NO
	D=dd
	Y=yy
	X=xx
	beep()
endfunc


// 150 BLOCK UP PUSH
func int pushBlockUp(f151;int)
	if f151=NO then {
		if Y<2 then return(NO)
		dec(Y)
		J=readKvram(X,Y)
		switch J
			case 0
				dec(S)
			case 5
				return(NO)
		endswitch
	}
	// 151
	while YES
		Q=Y
		dec(Y)
		if Q<1 then {
			// 352
			Y=Q
			writeKvram(X,Y,J)
			return(NO)
		}
		B=readKvram(X,Y)
		if B<>0 then {
			// 162
			W=Y:V=X:U=B:Y=Q
			writeKvram(X,Y,J)
			return (hajikuBlock())
		}
		moveBlockEraseY()
	endwhile
endfunc

// 155 BLOCK RIGHT PUSH
func int pushBlockRight(f156;int)
	if f156=NO then {
		if X>4 then return (NO)
		inc(X)
		J=readKvram(X,Y)
		switch J
			case 0
				dec(S)
			case 5
				return(NO)
		endswitch
	}
	// 156
	while YES
		P=X
		inc(X)
		if X>6 then {
			// 357
			X=P
			writeKvram(X,Y,J)
			return(NO)
		}
		B=readKvram(X,Y)
		if B<>0 then {
			// 167
			W=Y:V=X:U=B:X=P
			writeKvram(X,Y,J)
			return (hajikuBlock())
		}
		moveBlockEraseX()
	endwhile
endfunc

// 160 BLOCK DOWN PUSH
func int pushBlockDown(f161;int)
	if f161=NO then {
		if Y>4 then return(NO)
		inc(Y)
		J=readKvram(X,Y)
		switch J
			case 0
				dec(S)
			case 5
				return(NO)
		endswitch
	}
	// 161
	while YES
		Q=Y
		inc(Y)
		if Y>6 then {
			// 352
			Y=Q
			writeKvram(X,Y,J)
			return(NO)
		}
		B=readKvram(X,Y)
		if B<>0 then {
			// 162
			W=Y:V=X:U=B:Y=Q
			writeKvram(X,Q,J)
			return (hajikuBlock())
		}
		moveBlockEraseY()
	endwhile
endfunc

// 165 BLOCK LEFT PUSH
func int pushBlockLeft(f166;int)
	if f166=NO then {
		if X<2 then return(NO)
		dec(X)
		J=readKvram(X,Y)
		switch J
			case 0
				dec(S)
			case 5
				return(NO)
		endswitch
	}
	// 166
	while YES
		P=X
		dec(X)
		if P<1 then {
			// 357
			X=P
			writeKvram(X,Y,J)
			return(NO)
		}
		B=readKvram(X,Y)
		if B<>0 then {
			// 167
			W=Y:V=X:U=B:X=P
			writeKvram(X,Y,J)
			return (hajikuBlock())
		}
		moveBlockEraseX()
	endwhile
endfunc

// 370 BLOCK WO HAJIKU
func int hajikuBlock()
	if T>10 then T=0:return(NO)
	inc(T)
	if U>4 then return(NO)
	switch J
		case 2:// LEFT BLOCK
			turnDirecLeft()
			J=U
			X=V:Y=W
			return (YES):// @GOTO D*5+151;	151,156,161,166
		case 3:// RIGHT BLOCK
			turnDirecRight()
			J=U
			X=V:Y=W
			return (YES):// @GOTO D*5+151;	151,156,161,166
	endswitch
	switch U
		case 2:// LEFT BLOCK
			turnDirecLeft()
			break
		case 3:// RIGHT BLOCK
			turnDirecRight()
			break
	endswitch
	return (YES):// @GOTO D*5+151;	151,156,161,166
endfunc

// 385 DIR LEFT TURN
func turnDirecLeft()
	if D=0 then D=3 else dec(D)
endfunc

// 386 DIR RIGHT TURN
func turnDirecRight()
	inc(D)
	if D=4 then D=0
endfunc

// 390 BLOCK ERASE MOVE Y
func moveBlockEraseY()
	wait(0.2,NO)
	printBlock(X,Q,0)
	writeKvram(X,Q,0)
	printBlock(X,Y,J)
	waitEnd()
endfunc

// 391 BLOCK ERASE MOVE X
func moveBlockEraseX()
	wait(0.2,NO)
	printBlock(P,Y,0)
	writeKvram(P,Y,0)
	printBlock(X,Y,J)
	waitEnd()
endfunc

// 900 BLOCK PRINT
func printBlock(X;int,Y;int,B;int)
	if B>5 then B=0:// 内部コード６は表示上は０
	int A=X*3+2
	int C=Y*3+2
	str s1,s2,s3
	s1= "＋－＋"
	s3= "＋－＋"
	switch B
		case 5
			s1="・■・"
			s2="■■■"
			s3="・■・"
			break
		case 0
			s1= "　　　"
			s2= "　　　"
			s3= "　　　"
			break
		case 1
			s2= "｜　｜"
			break
		case 2
			s2= "｜Ｌ｜"
			break
		case 3
			s2= "｜Ｒ｜"
			break
		case 4
			s2= "｜＊｜"
			break
	endswitch
	locate(A,C  ):print s1
	locate(A,C+1):print s2
	locate(A,C+2):print s3
endfunc

// KVRAM ADDRESS
func int kvramAddress(X;int,Y;int)
	return (Y*MWX+X)
endfunc

// 952 KVRAM READ
func int readKvram(X;int,Y;int)
	int p=kvramAddress(X,Y)
	return (men1(p))
endfunc

// 953 KVRAM WRITE
func writeKvram(X;int,Y;int,B;int)
	int p=kvramAddress(X,Y)
	men1(p)=B
endfunc

// 965 MEN TENSOU  READ
func copyMenData()
	int p=R*MEN_DATAS
	int i
	for i=0 to MEN_DATAS-1
		men1(i)=men(p)
		p=p+1
	next
	// オリジナルはなぜか50バイト=MEN_DATAS+1転送している
endfunc

// 970 MEN PRINT
func printMen()
	int Y=0
	repeat
		int X=0
		repeat
			int p=kvramAddress(X,Y)
			printBlock(X,Y,men1(p))
			inc(X)
		until X=MWX
		inc(Y)
	until Y=MWY
endfunc

// 975 WAKU PRINT
func printWaku()
	locate(1,1):print utf8String$(23,"＊");
	Y=2
	repeat
		locate(1,Y):print "＊";utf8String$(21,"　");"＊";
		inc(Y)
	until Y=23
	locate(1,23):print utf8String$(23,"＊");
endfunc

// 980 SCREEN PRINT
func printScreen()
	printTitle()
	printStep()
	printLife()
	printRound()
endfunc

// 990 TITLE PRINT
func printTitle()
	locate(25, 2):print " @@  @@@  @@ "
	locate(25, 3):print "@			 @"
	locate(25, 4):print "@ PUSH BON! @"
	locate(25, 5):print "@			 @"
	locate(25, 6):print " @@  @@@  @@ "
	locate(25,17):print "For X-BASIC"
	locate(25,18):print "by AIG-SOFT"
	locate(25,21):print "FOR TTI"
	locate(25,22):print "BY J.YAMADA"
endfunc

// 899 STEP PRINT
func printStep()
	locate(26,8):print using "STEP  ###",S
endfunc

// 991 ROUND PRINT
func printRound()
	locate(26,12):print using "ROUND ###",R+1
endfunc

// 992 LIFE PRINT
func printLife()
	locate(26,10):print using "LIFE  ###",G
endfunc

// 993 DIRECTION PRINT
func printDirection(x;int,y;int)
	x=x*3+2
	y=y*3+2
	switch D
		case MOVE_UP
			locate(x+1,y)  :print "↑"
			locate(x+1,y+1):print "↑"
			locate(x+1,y+2):print "↑"
			break
		case MOVE_RIGHT
			locate(x,y+1):print "→→→"
			break
		case MOVE_DOWN
			locate(x+1,y)  :print "↓"
			locate(x+1,y+1):print "↓"
			locate(x+1,y+2):print "↓"
			break
		case MOVE_LEFT
			locate(x,y+1):print "←←←"
			break
	endswitch
endfunc

//-----------------

func waitEnd()
	repeat
	until wait(0)
endfunc

//****************************************************************
// キー入力
//****************************************************************

func printKeys(x;int,y;int)
	enum
		XC=3
		YC=3
	endenum
	int K1X=16*4,K1Y=16*4
	x=x*16
	y=y*16
	str dev=devicePlatform()
	if (left$(dev,4)<>"iPad") then {
		K1X=16*2
		K1Y=16*2
		x=x/2-6
		y=y/2-6
	}
	if touchallcnt =0 then {
		vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
		vpage(B_TPAGE+B_GPAGE0+B_GPAGE1+B_GPAGE2+B_GPAGE3)
		apage(GPAGE0)
		dim int keys( XC*YC-1)={0,KUP,0,KLEFT,KSPC,KRIGHT,0,KDOWN,0}
		dim str disps(XC*YC-1)={" ","↑"," ","←","押","→"," ","↓"," "}
		touchallcnt =setTouchKeys(x,y,XC,YC,K1X,K1Y,keys,disps,"Migu-1M-Regular",touchNo)
	}
endfunc

func removeKeys()
// 全タッチアリアの解除 / reset all key touch area
	resetAllTouchKeys(touchNo,touchallcnt)
	touchallcnt =0:// 登録してないの印
endfunc
